// AUTHER DANIEL GADD
// THIS CLASS IS A SIMPLE MARKER FOR WHEN WE TOUCH AND HOLD DOWN OUR FINGER WHEN THE MOVE COMMAND IT SELECTED
// IT HAS NO FUCNTIONALITY , IT IS SIMPLY A VISUAL MARKER
// IT USES THE SELECTED COUNT TO MAKE A SQUARE SHAPE WITH THE CORRECT NUMBER OF SELECTED GAME OBJECTS
// THIS CLASS WAS NOT USED TO ITS FULL POTENTIAL 

#ifndef GADDBOX_MARKER_H
#define GADDBOX_MARKER_H

#include "cocos2d.h"

#include "SessionData.h"
#include "Utils.h"

class Marker : public cocos2d::Node {

	public:

		Marker() {};
		~Marker() {};

		bool init(int count, int type = 1); // EVERYTIME WE HOLD DOWN OUR TOUCH WITH THE MOVE COMMAND ACTIVATE, THIS FUNCTION IS CALLED 
		bool finished() { return m_Finished; };// UN-USED
		bool getDelete() { return m_Delete; };// UN-USED

		void update(float distance = 0.0f); // DRAW PRIMITIVE OBJECTS, ONE FOR EACH NODE
		void setNodes(std::vector<cocos2d::Node*> nodes) { m_Nodes = nodes; }; // UN-USED
		void clear(); // DELETE ALL NODES AFTER WE LET GO OF THE TOUCH

		float getRest() { return m_Rest; }; // RETURN IF THE MARKER IS AT REST

		std::vector<cocos2d::Node*>& getNodes() { return m_Nodes; }; // RETRIEVE THE NODES 
		
	private:

		float distance(); // UN-USED - GETS DISTANCE FROM ONE POINT TO ANOTHER
		float getAngleDiff(float x, float y); // RETRIEVE DIFFERENCE BETWEEN TWO ANGLES

		void rotate(); // ROATE OBJECT CLOCKWISE OR ANTI-CLOCKWISE

		SessionData* m_SessionData; // SESSION DATA HANDLE
		Utils* m_Utils; // UTILITY HANDLE

		// VECTOR OF NODES TO WHICH WILL BE OF COUNT SELECTED.COUNT
		std::vector<cocos2d::Node*> m_Nodes;
		std::vector<cocos2d::Node*>::iterator m_Nodes_Iter;

		int m_Count;
		int m_Type;

		cocos2d::Vec2 m_Target;
		cocos2d::Vec2 m_Position;

		float m_Speed;
		float m_Distance;
		float m_Rest;
		float m_Space;
		float m_Steer;

		bool m_Reached;
		bool m_Finished;
		bool m_ClockWise;
		bool m_Delete;
};

#endif // GADDBOX_MARKER_H