#include "ContactListener.h"


void ContactListener::BeginContact(b2Contact * contact) {

	b2Body *bodyA = contact->GetFixtureA()->GetBody();
	b2Body *bodyB = contact->GetFixtureB()->GetBody();

	cocos2d::Sprite* spriteA = (cocos2d::Sprite*)bodyA->GetUserData();
	cocos2d::Sprite* spriteB = (cocos2d::Sprite*)bodyB->GetUserData();

	spriteA->setTag(101);
	spriteA->setTag(101);

}

void ContactListener::EndContact(b2Contact * contact) {

	b2Body *bodyA = contact->GetFixtureA()->GetBody();
	b2Body *bodyB = contact->GetFixtureB()->GetBody();

	cocos2d::Sprite* spriteA = (cocos2d::Sprite*)bodyA->GetUserData();
	cocos2d::Sprite* spriteB = (cocos2d::Sprite*)bodyB->GetUserData();

	spriteA->setTag(102);
	spriteA->setTag(102);

}